## hamster-time-tracker 3.0.2

=== wscript ===
# -*- python -*-


from subprocess import getstatusoutput

from waflib import Utils


# slight code duplication with hamster/__init__.py, but this is finally cleaner.
rc, output = getstatusoutput("git describe --tags --always --dirty=+")
VERSION = "3.0.2" if rc else output

APPNAME = 'hamster'

top = '.'
out = 'build'


def options(ctx):
    ctx.load('gnu_dirs')

    # the waf default value is /usr/local, which causes issues (e.g. #309)
    # ctx.parser.set_defaults(prefix='/usr') did not update the help string,
    # hence need to replace the whole option
    ctx.parser.remove_option('--prefix')
    default_prefix = '/usr'
    
    ctx.add_option('--prefix', dest='prefix', default=default_prefix,
                   help='installation prefix [default: {}]'.format(default_prefix))
    
    ctx.add_option('--skip-gsettings', dest='skip_gsettings', action='store_true',
                   help='skip gsettings schemas build and installation (for packagers)')
    
    ctx.add_option('--skip-icon-cache-update', dest='skip_icon_cache_update', action='store_true',
                   help='skip icon cache update (for packagers)')


def configure(ctx):
    ctx.load('gnu_dirs')  # for DATADIR
    
    if not ctx.options.skip_gsettings:
        ctx.load('glib2')  # for GSettings support
    
    ctx.load('python')
    ctx.check_python_version(minver=(3,4,0))

    ctx.load('intltool')

    ctx.env.ENABLE_NLS = 1
    ctx.env.HAVE_BIND_TEXTDOMAIN_CODESET = 1

    ctx.env.VERSION = VERSION
    ctx.env.GETTEXT_PACKAGE = "hamster"
    ctx.env.PACKAGE = "hamster"
    
    ctx.recurse("help")
    
    # options are tied to a specific ./waf invocation (one terminal line),
    # and woud have to be given again at any other ./waf invocation
    # that is trouble when one wants to ./waf uninstall much later;
    # it can be hard to remember the exact options used at the install step.
    # So from now on, options have to be given at the configure step only.
    # copy the options to the persistent env:
    for name in ('prefix', 'skip_gsettings', 'skip_icon_cache_update'):
        value = getattr(ctx.options, name)
        setattr(ctx.env, name, value)
   

def build(ctx):
    ctx.install_as('${LIBEXECDIR}/hamster/hamster-service', "src/hamster-service.py", chmod=Utils.O755)
    ctx.install_as('${LIBEXECDIR}/hamster/hamster-windows-service', "src/hamster-windows-service.py", chmod=Utils.O755)
    ctx.install_as('${BINDIR}/hamster', "src/hamster-cli.py", chmod=Utils.O755)


    ctx.install_files('${PREFIX}/share/bash-completion/completions',
                      'src/hamster.bash')


    ctx(features='py',
        source=ctx.path.ant_glob('src/hamster/**/*.py'),
        install_from='src')

    # set correct flags in defs.py
    ctx(features="subst",
        source="src/hamster/defs.py.in",
        target="src/hamster/defs.py",
        install_path="${PYTHONDIR}/hamster"
        )

    ctx(features="subst",
        source= "org.gnome.Hamster.service.in",
        target= "org.gnome.Hamster.service",
        install_path="${DATADIR}/dbus-1/services",
        )

    ctx(features="subst",
        source= "org.gnome.Hamster.GUI.service.in",
        target= "org.gnome.Hamster.GUI.service",
        install_path="${DATADIR}/dbus-1/services",
        )

    ctx(features="subst",
        source= "org.gnome.Hamster.WindowServer.service.in",
        target= "org.gnome.Hamster.WindowServer.service",
        install_path="${DATADIR}/dbus-1/services",
        )

    # look for wscript into further directories
    ctx.recurse("po data help")

=== data/wscript ===
# This file is meant to be included in the root wscript,
# through the recurse("data") command.
# An advantage of keeping it there
# instead of blending it in the root wscript build() 
# is that the files are looked for in the same folder
# (no need to prepend data/ everywhere)

import os

from waflib import Logs


def build(ctx):
    if not ctx.env.skip_gsettings:
        ctx(features='glib2',
            settings_schema_files=['org.gnome.hamster.gschema.xml'])

    ctx.install_files('${DATADIR}/metainfo', 'org.gnome.Hamster.GUI.metainfo.xml')

    filename = "org.gnome.Hamster.GUI.desktop"
    ctx(features = "subst",
        source= "%s.in" % filename,
        target= "%s" % filename,
        dict = ctx.env,
        install_path = "${DATADIR}/applications"
       )
    
    start_dir = ctx.path.find_dir('.')
    
    # glade builder files
    ctx.install_files('${DATADIR}/hamster', start_dir.ant_glob('*.ui'))
    # default files
    ctx.install_files('${DATADIR}/hamster', 'hamster.db')
    ctx.install_files('${DATADIR}/hamster', 'report_template.html')
    
    # icons
    ctx.install_files('${DATADIR}/hamster/art', start_dir.ant_glob('art/*.png'))
    ctx.install_files('${DATADIR}/icons/hicolor/16x16/apps',   'art/16x16/org.gnome.Hamster.GUI.png')
    ctx.install_files('${DATADIR}/icons/hicolor/22x22/apps',   'art/22x22/org.gnome.Hamster.GUI.png')
    ctx.install_files('${DATADIR}/icons/hicolor/24x24/apps',   'art/24x24/org.gnome.Hamster.GUI.png')
    ctx.install_files('${DATADIR}/icons/hicolor/32x32/apps',   'art/32x32/org.gnome.Hamster.GUI.png')
    ctx.install_files('${DATADIR}/icons/hicolor/48x48/apps',   'art/scalable/org.gnome.Hamster.GUI.png')
    ctx.install_files('${DATADIR}/icons/hicolor/scalable/apps','art/scalable/org.gnome.Hamster.GUI.svg')

    if not ctx.env.skip_icon_cache_update:
        ctx.add_post_fun(update_icon_cache)


# icon cache update
def update_icon_cache(ctx):
    """Update the gtk icon cache."""
    if ctx.cmd == "install":
        # adapted from the previous waf gnome.py
        icon_dir = os.path.join(ctx.env.DATADIR, 'icons/hicolor')
        cmd = 'gtk-update-icon-cache -q -f -t {}'.format(icon_dir)
        err = ctx.exec_command(cmd)
        if err:
            Logs.warn('The following  command failed:\n{}'.format(cmd))
        else:
            Logs.pprint('YELLOW', 'Successfully updated GTK icon cache')

=== debian/changelog ===
hamster-time-tracker (3.0.2-3) unstable; urgency=medium

  * No change source upload to get into testing.

 -- Raphaël Hertzog <hertzog@debian.org>  Tue, 25 Aug 2020 11:22:27 +0200

hamster-time-tracker (3.0.2-2) unstable; urgency=medium

  * Document CC-BY-SA-3.0 license for help files and SVG icon

 -- Raphaël Hertzog <hertzog@debian.org>  Thu, 13 Aug 2020 00:23:31 +0200

hamster-time-tracker (3.0.2-1) unstable; urgency=medium

  [ Matthijs Kooijman ]
  * Initial release. Closes: #697781

  [ Raphaël Hertzog ]
  * Synchronize the packaging with my own parallel work
  * Modify the HTML report template to use local version of JQuery
  * Install the upstream changelog
  * Add Vcs-* headers and use tracker team as maintainer
  * Add a watch file
  * Fix capitalization of GNOME
  * Use versioned copyright format URI.
  * Update copyright file header to use current field names (Upstream-
    Maintainer => Upstream-Contact)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Improve the copyright file to be more accurate

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 07 Aug 2020 23:19:32 +0200

=== debian/control ===
Source: hamster-time-tracker
Section: gnome
Priority: optional
Maintainer: Project Hamster Team <team+project-hamster@tracker.debian.org>
Uploaders: Raphaël Hertzog <hertzog@debian.org>, Matthijs Kooijman <matthijs@stdin.nl>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 gir1.2-gtk-3.0,
 intltool,
 itstool,
 libglib2.0-bin,
 libglib2.0-dev,
 pkg-config,
 python3 (>= 3.5),
 python3-cairo,
 python3-dbus,
 python3-distutils,
 python3-gi,
 python3-xdg
Standards-Version: 4.5.0
Homepage: https://github.com/projecthamster/hamster
Vcs-Git: https://salsa.debian.org/projecthamster-team/hamster-time-tracker.git
Vcs-Browser: https://salsa.debian.org/projecthamster-team/hamster-time-tracker
Rules-Requires-Root: no

Package: hamster-time-tracker
Architecture: all
Depends:
 gir1.2-gtk-3.0,
 libjs-jquery,
 libjs-jquery-ui,
 python3-cairo,
 python3-dbus,
 python3-distutils,
 python3-gi,
 python3-xdg,
 ${misc:Depends},
 ${python3:Depends}
Recommends: gnome-shell-extension-hamster, yelp
Breaks: hamster-applet (<< 3.0.2)
Replaces: hamster-applet (<< 3.0.2)
Description: time tracking application for GNOME
 Project Hamster helps you to keep track of how much time you spend on various
 activities during the day.  Whenever you move from one task to another, you
 can change your current activity, or you can record time spent afterwards.
 .
 It can present graphical statistics of how long you have spent on each task,
 and may be useful for project management or keeping employee timesheets.
 .
 This package contains the background daemon and GNOME application, an
 extension to integrate into the gnome-shell top bar is separately available.

Package: hamster-applet
Architecture: all
Section: oldlibs
Depends: hamster-time-tracker, ${misc:Depends}
Description: Transitional package for hamster-applet
 This empty package depends on the new hamster-time-tracker package to ensure
 proper upgrades.
 .
 It can be safely removed once hamster has been installed.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python3

# Note that debhelper does not support waf, so below all relevant build
# steps are overridden to run waf instead of the default autodetected
# buildsystem (setup.py probably).

override_dh_auto_clean:
	./waf distclean
	rm -rf waflib/__pycache__ waflib/Tools/__pycache__ waflib/extras/__pycache__

override_dh_auto_configure:
	./waf configure --prefix=/usr --skip-icon-cache-update --skip-gsettings

override_dh_auto_build:
	./waf build

override_dh_auto_install:
	./waf install --destdir=debian/hamster-time-tracker

override_dh_auto_test:
	# Can't run tests, need installed gsetting schema
	# python3 -m unittest tests.test_stuff

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md

execute_after_dh_python3:
	# Also scan this directory for python scripts
	dh_python3 /usr/libexec

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d.*)\.tar\.gz%@PACKAGGE-$1.tar.gz%, \
      uversionmangle=s%-(rc\d+|beta|)%~$1%" \
https://github.com/projecthamster/hamster/tags \
	.*/archive/v?@ANY_VERSION@.tar.gz

## hamster-time-tracker 3.0.3

=== wscript ===
--- 
+++ 
@@ -1,15 +1,13 @@
 # -*- python -*-
 
 
-from subprocess import getstatusoutput
+import subprocess
 
 from waflib import Utils
 
-
-# slight code duplication with hamster/__init__.py, but this is finally cleaner.
-rc, output = getstatusoutput("git describe --tags --always --dirty=+")
-VERSION = "3.0.2" if rc else output
-
+# Reuse code from hamster to figure out the version number to use
+process = subprocess.run(["python3", "src/hamster/version.py"], check=True, stdout=subprocess.PIPE, text=True)
+VERSION = process.stdout
 APPNAME = 'hamster'
 
 top = '.'

=== data/wscript ===
--- 
+++ 
@@ -15,7 +15,13 @@
         ctx(features='glib2',
             settings_schema_files=['org.gnome.hamster.gschema.xml'])
 
-    ctx.install_files('${DATADIR}/metainfo', 'org.gnome.Hamster.GUI.metainfo.xml')
+    filename = "org.gnome.Hamster.metainfo.xml"
+    ctx(features = "subst",
+        source= "%s.in" % filename,
+        target= "%s" % filename,
+        dict = ctx.env,
+        install_path = "${DATADIR}/metainfo"
+       )
 
     filename = "org.gnome.Hamster.GUI.desktop"
     ctx(features = "subst",

=== help/wscript ===
# waf script called from the root wscript, by
# conf.recurse("help")

# Mallard waf adaptor written by Ulrik Sverdrup
# may be distributed, changed, used, etc freely for any purpose

## Mallard functionality definitions ##
import os
from waflib import Logs, TaskGen

def _read_makefile_am(filename):
	"read a Makefile.am file for HELP_* variable definitions, return a dict"
	varstring = open(filename).read()
	varstring = varstring.replace("\\\n", " ")
	varlines = [L for L in varstring.splitlines() if L.startswith("HELP")]
	return dict(tuple(map(str.strip, var.split("=", 1))) for var in varlines)

def init_mallard(self):
	mf_am = self.path.find_resource(self.variable_definitions)
	HELP_VAR = _read_makefile_am(mf_am.abspath())

	require_vars = "HELP_ID HELP_LINGUAS HELP_FILES".split()
	have_vars = set(var for var in HELP_VAR if HELP_VAR[var])
	missing_vars = set(require_vars).difference(have_vars)
	if missing_vars:
		print("Missing HELP variable declarations in {}:".format(mf_am.abspath()))
		print("\n".join(missing_vars))

	self.bld.env.update(HELP_VAR)
	self.default_install_path='${PREFIX}/share/help'

def apply_mallard(self):
	bld = self.bld
	lst = self.to_list(bld.env["HELP_LINGUAS"])
	cnode = self.path.find_dir("C")

	pages = [p.name for p in cnode.ant_glob(["*.page", "*.xml"])]

	# Check if the declared page list is consistent
	declared_pages = self.to_list(bld.env["HELP_FILES"])
	missing_pages = set(pages).difference(declared_pages)
	if missing_pages:
		print("Warning: Some pages not declared:")
		print("\n".join(missing_pages))

	install_path = lambda lang: os.path.join(bld.env.DATADIR, "help", lang, "${HELP_ID}")

	for lang in lst:
		node = self.path.find_resource("%s/%s.po" % (lang, lang))
		mo = self.path.find_or_declare("%s/%s.mo" % (lang, lang))
		bld(name='msgfmt', color='BLUE',
		    rule='${MSGFMT} ${SRC} -o ${TGT}',
		    source=node,
		    target=mo,
		    )
		for page in pages:
			out = self.path.find_or_declare('%s/%s' % (lang, page))
			src = self.path.find_resource('C/%s' % page)
			bld(name='itstool', color='BLUE',
			    rule='${ITSTOOL} -m ${SRC} -o ${TGT}',
			    source=[mo, src],
			    target=out,
			    install_path=install_path(lang)
			    )

	if bld.is_install:
		page_nodes = [cnode.find_resource(page) for page in pages]
		instdir = install_path("C")
		bld.install_files(instdir, page_nodes)


TaskGen.feature("mallard")(init_mallard)
TaskGen.feature("mallard")(apply_mallard)
TaskGen.after('init_mallard')(apply_mallard)

## End Mallard functionality ##


# Build Configuration


def configure(ctx):
	lookfor = "itstool"
	try:
		ctx.find_program('msgfmt', var='MSGFMT')
		ctx.find_program(lookfor, var='ITSTOOL')
		ctx.env.docs = True
	except ctx.errors.ConfigurationError:
		Logs.warn("'{}' not found; documentation build disabled".format(lookfor))
		ctx.env.docs = False

def build(ctx):
	if ctx.env.docs:
		task = ctx(
			features="mallard",
			variable_definitions="Makefile.am",
		)

=== po/wscript ===
#!/usr/bin/env python2
# encoding: utf-8
# Thomas Nagy, 2006-2009 (ita)

def build(bld):
    bld(features = 'intltool_po', appname = 'hamster')

=== debian/changelog ===
hamster-time-tracker (3.0.3-3) unstable; urgency=medium

  * Add patch to fix invalid escape error messages. Thanks to Martina
    Ferrari <tina@debian.org> (Closes: #1085633)
  * Add patch to fix invalid appstream metadata

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 14 Mar 2025 16:24:55 +0100

hamster-time-tracker (3.0.3-2) unstable; urgency=medium

  * Add explicit python3-setuptools to Build-Depends
  * Replace pkg-config build dependency with pkgconf (lintian warning).
  * Bump Standards-Version to 4.7.0
  * Add new patch to really remove code relying on distutils.
  * Update meta-information of patch that got merged upstream.

 -- Raphaël Hertzog <hertzog@debian.org>  Sun, 22 Sep 2024 13:54:40 +0200

hamster-time-tracker (3.0.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop python3-distutils from Build-Depends and Depends (Closes: #1065873) 

 -- Tobias Frost <tobi@debian.org>  Sun, 14 Jul 2024 08:56:19 +0200

hamster-time-tracker (3.0.3-1) unstable; urgency=medium

  [ Raphaël Hertzog ]
  * Add patch to make build reproducible. Thanks to Chris Lamb
    <lamby@debian.org> (Closes: #1028310)
  * Add missing patch
  * Add dependency to python3-gi-cairo (Closes: #1036661)
  * Use upstream-vcs-tag to import the upstream git history
  * Remove hamster-applet transitional package (Closes: #1038333)
  * New upstream release. Closes: #1054220

  [ Matthijs Kooijman ]
  * Drop python3-xdg dependency
  * Remove Drop-deprecated-call-to-bind_textdomain_codeset.patch
  * Run waf with python3

 -- Raphaël Hertzog <hertzog@debian.org>  Thu, 23 Nov 2023 23:40:13 +0000

hamster-time-tracker (3.0.2-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

  [ Raphaël Hertzog ]
  * Fix hamster to work with Python 3.11. Remove call to
    gettext.bind_textdomaine_codeset() which was removed in Python 3.11.
  * Update standards version to 4.6.2, no changes needed.
  * Fix pattern in watch file

 -- Raphaël Hertzog <hertzog@debian.org>  Tue, 10 Jan 2023 10:09:42 +0100

=== debian/control ===
--- 
+++ 
@@ -11,14 +11,13 @@
  itstool,
  libglib2.0-bin,
  libglib2.0-dev,
- pkg-config,
- python3 (>= 3.5),
+ pkgconf,
+ python3,
  python3-cairo,
  python3-dbus,
- python3-distutils,
- python3-gi,
- python3-xdg
-Standards-Version: 4.5.0
+ python3-setuptools,
+ python3-gi
+Standards-Version: 4.7.0
 Homepage: https://github.com/projecthamster/hamster
 Vcs-Git: https://salsa.debian.org/projecthamster-team/hamster-time-tracker.git
 Vcs-Browser: https://salsa.debian.org/projecthamster-team/hamster-time-tracker
@@ -32,9 +31,8 @@
  libjs-jquery-ui,
  python3-cairo,
  python3-dbus,
- python3-distutils,
  python3-gi,
- python3-xdg,
+ python3-gi-cairo,
  ${misc:Depends},
  ${python3:Depends}
 Recommends: gnome-shell-extension-hamster, yelp
@@ -50,13 +48,3 @@
  .
  This package contains the background daemon and GNOME application, an
  extension to integrate into the gnome-shell top bar is separately available.
-
-Package: hamster-applet
-Architecture: all
-Section: oldlibs
-Depends: hamster-time-tracker, ${misc:Depends}
-Description: Transitional package for hamster-applet
- This empty package depends on the new hamster-time-tracker package to ensure
- proper upgrades.
- .
- It can be safely removed once hamster has been installed.

=== debian/rules ===
--- 
+++ 
@@ -8,17 +8,17 @@
 # buildsystem (setup.py probably).
 
 override_dh_auto_clean:
-	./waf distclean
+	python3 ./waf distclean
 	rm -rf waflib/__pycache__ waflib/Tools/__pycache__ waflib/extras/__pycache__
 
 override_dh_auto_configure:
-	./waf configure --prefix=/usr --skip-icon-cache-update --skip-gsettings
+	python3 ./waf configure --prefix=/usr --skip-icon-cache-update --skip-gsettings
 
 override_dh_auto_build:
-	./waf build
+	python3 ./waf build
 
 override_dh_auto_install:
-	./waf install --destdir=debian/hamster-time-tracker
+	python3 ./waf install --destdir=debian/hamster-time-tracker
 
 override_dh_auto_test:
 	# Can't run tests, need installed gsetting schema

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d.*)\.tar\.gz%@PACKAGGE-$1.tar.gz%, \
      uversionmangle=s%-(rc\d+|beta|)%~$1%" \
https://github.com/projecthamster/hamster/tags \
	.*/archive/refs/tags/v?@ANY_VERSION@.tar.gz
